#ifndef __GUI_CREATE_TORRENT_H_
#define __GUI_CREATE_TORRENT_H_

#include "torrent.h"

#include <gtkmm.h>

class gui_create_torrent : public Gtk::Window
{
  public:
    gui_create_torrent();
    ~gui_create_torrent();

  protected:
    void create();
    void cancel();
    void select_torrent_path();
    void add_file_dialog();
    void add_file();
    void add_tracker();

    Gtk::Button *cancel_btn;
    Gtk::Button *select_torrent_path_btn;
    Gtk::Button *create_btn;
    Gtk::Button *file_add_btn;
    Gtk::Button *tracker_add_btn;
    Gtk::Notebook tabs;
    Gtk::VBox files_page;
    Gtk::VBox trackers_page;
    Gtk::VBox box;
    Gtk::HBox m_path_box;
    Gtk::HBox m_btn_box;
    Gtk::Label lbl_save_path;
    Gtk::Entry ent_save_path;
    Gtk::CheckButton btn_start_seeding;

    /* Files Page */
    Gtk::HBox f_top_box;
    class FileColumns : public Gtk::TreeModel::ColumnRecord
    {
      public:
        FileColumns() {
            add(name);
        }

        Gtk::TreeModelColumn<Glib::ustring> name;
    };
    FileColumns fcol;
    Gtk::TreeView ftreeview;
    Glib::RefPtr<Gtk::ListStore> frefTreeModel;
    Gtk::ScrolledWindow f_scrolledwindow;

    /* Trackers Page */
    Gtk::HBox t_top_box;
    class TrackerColumns : public Gtk::TreeModel::ColumnRecord
    {
      public:
        TrackerColumns() {
            add(url);
        }

        Gtk::TreeModelColumn<Glib::ustring> url;
    };
    TrackerColumns tcol;
    Gtk::Entry ent_tracker_url;
    Gtk::Label lbl_tracker_url;
    Gtk::TreeView ttreeview;
    Glib::RefPtr<Gtk::ListStore> trefTreeModel;
    Gtk::ScrolledWindow t_scrolledwindow;

    Gtk::Label lbl_status;
};
#endif
