#ifndef _LOGGER__H_
#define _LOGGER__H_

#include <gtkmm.h>

class Logger : private Gtk::Window {
  public:
      Logger()
      {
          this->lbl_status_msg = new Gtk::Label("");
          this->lbl_status_download = new Gtk::Label("N/A");
          this->lbl_status_upload = new Gtk::Label("N/A");
          disable();
      }

      ~Logger()
      {
          delete this->lbl_status_msg;
          delete this->lbl_status_download;
          delete this->lbl_status_upload;
      }

      void update_status(float down, float up);

      void errorf(const char *err, ...);
      void warningf(const char *warn, ...);
      void messagef(const char *msg, ...);
      void error(const char *err, bool graphical=false) {
          output(Gtk::MESSAGE_ERROR, err, graphical);
      }
      void error(std::string err, bool graphical=false) {
          output(Gtk::MESSAGE_ERROR, err.c_str(), graphical);
      }
      void warning(const char *err, bool graphical=false) {
          output(Gtk::MESSAGE_WARNING, err, graphical);
      }
      void warning(std::string warn, bool graphical=false) {
          output(Gtk::MESSAGE_WARNING, warn.c_str(), graphical);
      }
      void message(const char *err, bool graphical=false) {
          output(Gtk::MESSAGE_INFO, err, graphical);
      }
      void message(std::string msg, bool graphical=false) {
          output(Gtk::MESSAGE_INFO, msg.c_str(), graphical);
      }
      void enable() {
          this->enabled = true;
      }
      void disable() {
          this->enabled = false;
      }

      Gtk::Label *lbl_status_msg;
      Gtk::Label *lbl_status_download;
      Gtk::Label *lbl_status_upload;
  private:
      bool enabled;
      void output(Gtk::MessageType type, const char *str, bool graphical);
};

extern Logger *g_logger;

#endif
