#include "settings.h"
#include "logger.h"

#include <gtkmm.h>

class Preferences : public Gtk::Window
{
  public:
    Preferences();
    ~Preferences();

    void saveSettings();
    void reset();

  protected:
    void on_download_dir_browse();
    void on_port_end_changed();
    void on_port_start_changed();
    void on_ok_btn_clicked();
    void on_cancel_btn_clicked();
    void on_resetdef_btn_clicked();
    void restart_required_msg();

    Gtk::Label lbl_download_dir;
    Gtk::Label lbl_port_range;
    Gtk::Label lbl_upload_rate_limit;
    Gtk::Label lbl_download_rate_limit;
    Gtk::Label lbl_upload_slot_limit;
    Gtk::Label lbl_refresh_rate;
    Gtk::Label lbl_storage_mode;
    Gtk::Label lbl_global_uprate;
    Gtk::Label lbl_action_on_completion;

    Gtk::CheckButton btn_notifications;
    Gtk::CheckButton btn_upnp;
    Gtk::CheckButton btn_natpmp;
    Gtk::Entry  ent_download_dir;
    Gtk::Button ent_download_dir_btn;
    Gtk::HScale ent_port_start;
    Gtk::HScale ent_port_end;
    Gtk::HScale ent_upload_rate_limit;
    Gtk::HScale ent_download_rate_limit;
    Gtk::HScale ent_upload_slot_limit;
    Gtk::HScale ent_refresh_rate;
    Gtk::HScale ent_global_uprate;
    Gtk::ComboBoxText ent_storage_mode;
    Gtk::ComboBoxText ent_action_on_completion;

    Gtk::Button *ok_btn;
    Gtk::Button *cancel_btn;
    Gtk::Button *reset_btn;
    Gtk::Button *resetdef_btn;

    Gtk::Notebook tabs;
    Gtk::VBox downloads_page;
    Gtk::VBox network_page;
    Gtk::VBox gui_page;
    Gtk::VBox extra_page;
    Gtk::VBox box;

    Gtk::HBox m_download_dir_box;
    Gtk::HBox m_btn_box;

    int tmp_port_start;
    int tmp_port_end;
};
