#ifndef _TOOLS__H_
#define _TOOLS__H_

#include <string>
#include <fstream>
#include <cstdlib>
#include <iterator>
#include <cstring>
#include <math.h>
#include <stdio.h>

#ifdef WIN32
#define DIR_SEP '\\'
#else
#define DIR_SEP '/'
#endif

enum Priorities_e {
    PRIO_SKIP = 0,
    PRIO_NORMAL,
    PRIO_FAIRLY_HIGH,
    PRIO_PRETTY_HIGH,
    PRIO_HIGH_2,
    PRIO_HIGH,
    PRIO_MAX,
    PRIO_SUPERMAX,

    PRIO_END
};

enum States_e {
    STATE_QUEUED = 0,
    STATE_CHECKING,
    STATE_DOWNLOADING,
    STATE_GATHERING_METADATA,
    STATE_DOWNLOADING_2,
    STATE_FINISHED,
    STATE_SEEDING,
    STATE_ALLOCATING,
    STATE_PAUSED,

    STATE_END
};

std::string urldecode(std::string url);
const char* fix_rate(float val);
unsigned get_eta(float dspeed, long total_size, long downloaded);
std::string fix_time(unsigned s, int args = 3);
const char* prio_name(const unsigned int prio);
const char* state_name(const unsigned int state);
std::string truncate(std::string str, unsigned int len);
long filesize(const std::string path);
bool pipe_append(const char *str);

#endif
